using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace UWB_GUI
{
    public class UWB_UI_RadioButtonSet : UWB_UI_Element
    {
        private UWB_UI_RadioButton m_CurrentlySelected;
        private List<UWB_UI_RadioButton> m_RadioButtons;

        public UWB_UI_RadioButtonSet()
        {
            m_RadioButtons = new List<UWB_UI_RadioButton>();
            m_CurrentlySelected = null;
        }

        public void AddRadioButton(UWB_UI_RadioButton radioButton)
        {
            m_RadioButtons.Add(radioButton);
            //need to change how bounds are handled
            m_Bounds = radioButton.GetBounds();
        }

        public void RemoveRadioButton(UWB_UI_RadioButton radioButton)
        {
            try
            {
                m_RadioButtons.Remove(radioButton);
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
            }
        }

        public override void SetHighlighted(Microsoft.Xna.Framework.Point mousePosition)
        {
            foreach (UWB_UI_RadioButton item in m_RadioButtons)
            {
                item.SetHighlighted(mousePosition);
            }
            base.SetHighlighted(mousePosition);
        }

        public void SetSelectedRadioButton(UWB_UI_RadioButton radioButton)
        {
            if (m_RadioButtons.Contains(radioButton))
            {
                if (m_CurrentlySelected != radioButton)
                {
                    m_CurrentlySelected.IsSelected = false;
                }
                m_CurrentlySelected = radioButton;
                m_CurrentlySelected.IsSelected = true;
            }
        }

        public void SetSelectedRadioButton(String label)
        {
            foreach (UWB_UI_RadioButton item in m_RadioButtons)
            {
                if (item.Text.Equals(label))
                {
                    item.IsSelected = true;
                    m_CurrentlySelected = item;
                }
                else
                {
                    item.IsSelected = false;
                }
            }
        }

        public UWB_UI_RadioButton GetSelectedRadioButton()
        {
            return m_CurrentlySelected;
        }

        public override void SetSelected(Microsoft.Xna.Framework.Point mousePosition)
        {
            foreach (UWB_UI_RadioButton item in m_RadioButtons)
            {
                if (item.GetBounds().Contains(mousePosition))
                {
                    if (m_CurrentlySelected != item)
                    {
                        if (m_CurrentlySelected != null)
                        {
                            m_CurrentlySelected.IsSelected = false;
                        }
                        m_CurrentlySelected = item;
                        m_CurrentlySelected.IsSelected = true;
                        ExecuteValueChangedListeners();
                    }
                    break;
                }
            }
        }

        public override void Draw(GraphicsDevice graphics, SpriteBatch spriteBatch)
        {
            foreach (UWB_UI_RadioButton item in m_RadioButtons)
            {
                item.Draw(graphics, spriteBatch);
            }
        }
    }
}
