using System;
using System.Collections.Generic;
using System.Text;
#if XBOX360
#else
using System.Windows.Forms;
#endif

namespace XNALib
{
    public class UWB_IWindowHandler
    {
        public virtual bool IsGraphicsDeviceValid() { return false; }
#if XBOX360
        public virtual bool InitializeHandler(int deviceWidth, int deviceHeight) { return true; }
#else
        public virtual bool InitializeHandler(IntPtr h_AttachedWindow) { return false; }
#endif
        public virtual void ShutDownHandler() { }

        public virtual void BeginScene() { }
        public virtual void EndSceneAndShow() { }
        public virtual void DrawGraphics() { }

#if XBOX360
        /// Called when the mouse is clicked down or up on a graphics window
        /// Note: Currently, this implementation only handles left mouse button
        /// \param down [in]: true if the left mouse button is clicked down
        /// \param hwX, hwY [in]: client window coordinates of the cursor
        public virtual void OnMouseButton(bool down, int hwX, int hwY) { }

        /// Called when the mouse is moved over a graphics window
        /// Note: Currently, this implementation only handles left mouse button
        /// \param down [in]: true if the left mouse button is clicked down
        /// \param hwX, hwY [in]: client window coordinates of the cursor
        public virtual void OnMouseMove(bool down, int hwX, int hwY) { }
#else
        public virtual void OnMouseButton(bool down, MouseEventArgs e) { }
        public virtual void OnMouseMove(MouseEventArgs e) { }
#endif
    }
}
