using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework.Graphics;

namespace UWB_XNALib
{
    public class UWB_XNAPrimitiveMeshAxis : UWB_Primitive
    {
        protected UWB_XNAPrimitiveMeshArrow m_xaxis;
        protected UWB_XNAPrimitiveMeshArrow m_yaxis;
        protected UWB_XNAPrimitiveMeshArrow m_zaxis;

        public UWB_XNAPrimitiveMeshAxis() 
        {
            m_xaxis = new UWB_XNAPrimitiveMeshArrow();
            m_yaxis = new UWB_XNAPrimitiveMeshArrow();
            m_zaxis = new UWB_XNAPrimitiveMeshArrow();
            m_xaxis.setFlatColor(new Color(255, 0, 0));
            m_yaxis.setFlatColor(new Color(0, 255, 0));
            m_zaxis.setFlatColor(new Color(0, 0, 255));
        }

        protected override void DrawPrimitive(eLevelofDetail lod, UWB_DrawHelper draw_helper)
        {
            draw_helper.pushModelTransform();
            {
                m_xaxis.Draw(lod, draw_helper);
            }
            draw_helper.popModelTransform();

            UWB_XFormInfo yrot = new UWB_XFormInfo();
            yrot.UpdateRotationZByDegree(-90.0f);
            draw_helper.pushModelTransform();
            {
                yrot.setupModelStack(draw_helper);
                m_yaxis.Draw(lod, draw_helper);
            }
            draw_helper.popModelTransform();

            UWB_XFormInfo zrot = new UWB_XFormInfo();
            zrot.UpdateRotationYByDegree(90.0f);
            draw_helper.pushModelTransform();
            {
                zrot.setupModelStack(draw_helper);
                m_zaxis.Draw(lod, draw_helper);
            }
            draw_helper.popModelTransform();
        }
        

    }

}
