using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWB_GUI;
using UWB_XNALib;
using XNA_UI_Controls;

namespace XNAMultipleLights
{
    public class DrawOnlyHandler : ViewportHandler
    {
        protected Model m_Model;

        public DrawOnlyHandler(Rectangle deviceBounds, Rectangle worldBounds, Model model, XNA_UI_GUI gui)
            : base(deviceBounds, worldBounds, gui)
        {
            m_Model = model;
            m_Camera = new UWB_Camera();
            m_Camera.CameraPosition = new Vector3(10, 10, 25);
            m_Camera.CameraLookAt = Vector3.Zero;
            m_Camera.CameraUp = Vector3.Up;
            m_Camera.FarClipping = 50.0f;
            m_Camera.NearClipping = 0.1f;
            m_Camera.FoV = (float)Math.PI / 4f;

        }

        public DrawOnlyHandler(Rectangle deviceBounds, Model model, XNA_UI_GUI gui)
            : this(deviceBounds, model.WorldBounds, model, gui) { }

        public DrawOnlyHandler(Rectangle deviceBounds, XNA_UI_GUI gui)
            : base(deviceBounds, deviceBounds, gui)
        {
            m_Model = null;
            m_Camera = new UWB_Camera();
            m_Camera.CameraPosition = new Vector3(10, 10, 25);
            m_Camera.CameraLookAt = Vector3.Zero;
            m_Camera.CameraUp = Vector3.Up;
            m_Camera.FarClipping = 50.0f;
            m_Camera.NearClipping = 0.1f;
            m_Camera.FoV = (float)Math.PI / 4f;

        }

        public override void DrawGraphics()
        {
            if (m_bVisible)
            {
                LoadW2NDCXform();
                LoadViewXform();
                LoadProjectionXform();

                BeginDraw();

                if (m_Model != null)
                    m_Model.DrawModel();

                EndDraw();
            }
        }
    }
}