using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWB_GUI;
using UWB_XNALib;

namespace XNA_UI_Controls
{
    public class EchoStatusBar : UWB_UI_Container
    {
        public const int margin = 5;
        public const int height = 23;
        public const int width = 250;

        private UWB_UI_Label m_StatusLabel;

        /// <summary>
        /// Creates a StatusBar Container that displays the string defined in UWB_Utility
        /// </summary>
        /// <param name="upperRight">Upper right coordinate to place status bar</param>
        public EchoStatusBar(Point upperRight, UWB_UI_GUI gui)
            : this(upperRight, gui.GetBaseContainer())
        { }

        internal EchoStatusBar(Point upperRight, UWB_UI_Container container)
            : base(upperRight.X, upperRight.Y, width, height, new Color(new Vector4(Color.Azure.ToVector3(), 0.8f)))
        {
            m_StatusLabel = new UWB_UI_Label(UWB_Utility.mEchoTextBox, new Vector2(margin, margin), this, UWB_UI_GUI.SmallFont);
            AddItem(new UWB_UI_Item("Status", m_StatusLabel));
            AddListener(new EchoStatusBarLabelListener(m_StatusLabel));

            container.AddItem(new UWB_UI_Item("Status Bar", this));
        }

        public SpriteFont Font
        {
            set { m_StatusLabel.Font = value; }
        }
    }
}
