using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWB_GUI;

namespace XNA_UI_Controls
{
    public class MouseStatusBar : UWB_UI_Container
    {
        public const int margin = 5;
        public const int height = 23;
        public const int width = 250;

        /// <summary>
        /// Creates a pre-defined StatusBar UWB_UI_Container
        /// </summary>
        /// <param name="upperRight">Upper right coordinate to place status bar</param>
        public MouseStatusBar(Point upperRight, UWB_UI_GUI gui)
            : this(upperRight, gui.GetBaseContainer())
        { }

        public MouseStatusBar(Point upperRight, UWB_UI_Container container)
            : base(upperRight.X, upperRight.Y, width, height, new Color(new Vector4(Color.Azure.ToVector3(), 0.8f)))
        {
            AddItem(new UWB_UI_Item("Status", new UWB_UI_Label("Status:", new Vector2(margin, margin), this, UWB_UI_GUI.SmallFont)));

            AddItem(new UWB_UI_Item("MouseLabel", new UWB_UI_Label("Mouse:", new Vector2(margin + 40, margin), this, UWB_UI_GUI.SmallFont)));
            UWB_UI_Label mousePosLabel = new UWB_UI_Label(UWB_UI_Mouse.Position.X.ToString("0") + ' ' + UWB_UI_Mouse.Position.Y.ToString("0"), new Vector2(margin + 80, margin), this, UWB_UI_GUI.SmallFont);
            AddItem("MousePosLabel", mousePosLabel);
            AddItem("LMBLabel", new UWB_UI_Label("LMB:", new Vector2(margin + 150, margin), this, UWB_UI_GUI.SmallFont));
            UWB_UI_Label LMBStateLabel = new UWB_UI_Label("", new Vector2(margin + 180, margin), this, UWB_UI_GUI.SmallFont);
            AddItem(new UWB_UI_Item("ButtonAStateLabel", LMBStateLabel));
            
            AddListener(new MousePosLabelListener(mousePosLabel));
            AddListener(new MouseButtonLabelListener(LMBStateLabel));

            container.AddItem(new UWB_UI_Item("Status Bar", this));
        }
    }
}
