using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using UWB_GUI;

namespace XNA_UI_Controls
{
    /// <summary>
    /// A listener that consumes mouse events when the mouse is within the UI_Element's bounds
    /// Works with any UWB_UI_Element object
    /// </summary>
    public class UI_ElementListener : UWB_UI_Listener
    {
        public override bool MousePressed(UWB_UI_Element obj)
        {
            return InBounds(obj);
        }

        public override bool MouseMoved(UWB_UI_Element obj)
        {
            return InBounds(obj);
        }

        public override bool MouseReleased(UWB_UI_Element obj)
        {
            return InBounds(obj);
        }

        public override bool MouseDragged(UWB_UI_Element obj)
        {
            return InBounds(obj);
        }

        protected bool InBounds(UWB_UI_Element obj)
        {
            return obj.GetBounds().Contains(new Point((int)UWB_UI_Mouse.Position.X, (int)UWB_UI_Mouse.Position.Y));
        }
    }
}
