using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using UWB_GUI;
using UWB_XNALib;

namespace XNA_UI_Controls
{
    public class XformInfoControlListener : UWB_UI_Listener
    {
        private string m_Type;

        private XformInfoControl m_XformInfoControl;

        public XformInfoControlListener(string type, XformInfoControl xFormControl)
        {
            m_Type = type;
            m_XformInfoControl = xFormControl;
        }

        public override bool ValueChanged(UWB_UI_Element obj)
        {
            if (obj.GetType() == typeof(UWB_UI_SliderBar))
            {
                // retreive sliderbar value and set current transform
                Vector3 tempVect = CurrentXFormValues;
                RetreiveSliderValue(ref tempVect, ((UWB_UI_SliderBar)obj).Value / 10f);
                CurrentXFormValues = tempVect;
            }
            else if (obj.GetType() == typeof(UWB_UI_RadioButtonSet))
                RadioButtonChanged();

            return false;
        }

        private void RetreiveSliderValue(ref Vector3 xformValues, float newValue)
        {
            switch (m_Type)
            {
                case "X":
                    xformValues.X = newValue;
                    break;
                case "Y":
                    xformValues.Y = newValue;
                    break;
                case "Z":
                    xformValues.Z = newValue;
                    break;
                default:
                    break;
            }
        }

        private void RadioButtonChanged()
        {
            m_XformInfoControl.UpdateSliderRanges();
            m_XformInfoControl.UpdateControlValues();
        }

        private Vector3 CurrentXFormValues
        {
            get { return m_XformInfoControl.CurrentXFormValues; }
            set { m_XformInfoControl.CurrentXFormValues = value; }
        }
    }
}
