using System;
using System.Collections.Generic;
using System.Text;
using UWB_GUI;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;
using UWB_XNALib;

namespace XNA_UI_Controls
{
    /// <summary>
    /// An extention of UWB_UI_GUI that allows for the handling of
    /// ViewportHandlerListeners separately from other types of listeners.
    /// </summary>
    public class XNA_UI_GUI : UWB_UI_GUI
    {
        private XNA_UI_Container m_ViewportHandlerContainer;

		public XNA_UI_GUI(Game game) : base(game)
		{
            m_ViewportHandlerContainer = new XNA_UI_Container(m_BaseContainer.X, m_BaseContainer.Y, m_BaseContainer.Width, m_BaseContainer.Height, Color.TransparentWhite);
		}

        public XNA_UI_Container ViewportHandlerContainer
        {
            get { return m_ViewportHandlerContainer; }
        }

        protected override bool LeftMouseButtonDown(Point mousePos)
        {
            if(!base.LeftMouseButtonDown(mousePos))
                return m_ViewportHandlerContainer.LeftMouseButtonDown(mousePos);

            return true;
        }

        protected override bool LeftMouseButtonDrag(Point mousePos)
        {
            if(!base.LeftMouseButtonDrag(mousePos))
                return m_ViewportHandlerContainer.LeftMouseButtonDrag(mousePos);

            return true;
        }

        protected override bool LeftMouseButtonReleased(Point mousePos)
        {
            if(!base.LeftMouseButtonReleased(mousePos))
                return m_ViewportHandlerContainer.LeftMouseButtonReleased(mousePos);

            return true;
        }

        protected override bool RightMouseButtonDown(Point mousePos)
        {
            if (!base.RightMouseButtonDown(mousePos))
                return m_ViewportHandlerContainer.RightMouseButtonDown(mousePos);

            return true;
        }

        protected override bool RightMouseButtonDrag(Point mousePos)
        {
            if (!base.RightMouseButtonDrag(mousePos))
                return m_ViewportHandlerContainer.RightMouseButtonDrag(mousePos);

            return true;
        }

        protected override bool RightMouseButtonReleased(Point mousePos)
        {
            if (!base.RightMouseButtonReleased(mousePos))
                return m_ViewportHandlerContainer.RightMouseButtonReleased(mousePos);

            return true;
        }

        protected override bool MiddleMouseButtonDown(Point mousePos)
        {
            if (!base.MiddleMouseButtonDown(mousePos))
                return m_ViewportHandlerContainer.MiddleMouseButtonDown(mousePos);

            return true;
        }

        protected override bool MiddleMouseButtonDrag(Point mousePos)
        {
            if (!base.MiddleMouseButtonDrag(mousePos))
                return m_ViewportHandlerContainer.MiddleMouseButtonDrag(mousePos);

            return true;
        }

        protected override bool MiddleMouseButtonReleased(Point mousePos)
        {
            if (!base.MiddleMouseButtonReleased(mousePos))
                return m_ViewportHandlerContainer.MiddleMouseButtonReleased(mousePos);

            return true;
        }

        protected override bool MouseMoved(Point mousePos)
        {
            if(!base.MouseMoved(mousePos))
                return m_ViewportHandlerContainer.MouseMoved(mousePos);

            return true;
        }
    }
}
