using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using UWB_GUI;

namespace XNA_UI_Controls
{
    public class ViewportHandlerListener : UWB_UI_Listener
    {
        private ViewportHandler m_ViewportHandler;

        public ViewportHandlerListener(ViewportHandler handler)
        {
            m_ViewportHandler = handler;
        }

        public override bool MousePressed(UWB_UI_Element obj)
        {
            Point mousePos;
            if (m_ViewportHandler.Visible && InBounds(out mousePos))
            {
                m_ViewportHandler.OnMouseButton(true, mousePos.X, mousePos.Y);
                return true;
            }
            return false;
        }

        public override bool MouseReleased(UWB_UI_Element obj)
        {
            Point mousePos;
            if (m_ViewportHandler.Visible && InBounds(out mousePos))
            {
                m_ViewportHandler.OnMouseButton(false, mousePos.X, mousePos.Y);
                return true;
            }
            return false;
        }

        public override bool MouseMoved(UWB_UI_Element obj)
        {
            Point mousePos;
            if (m_ViewportHandler.Visible && InBounds(out mousePos))
            {

                m_ViewportHandler.OnMouseMove(UWB_UI_Mouse.LeftMouseButtonDown ||
                    UWB_UI_Mouse.MiddleMouseButtonDown || UWB_UI_Mouse.RightMouseButtonDown,
                    mousePos.X, mousePos.Y);
                return true;
            }
            return false;
        }

        private bool InBounds(out Point mousePos)
        {
            mousePos = new Point((int)UWB_UI_Mouse.Position.X, (int)UWB_UI_Mouse.Position.Y);
            return m_ViewportHandler.Bounds.Contains(mousePos);
        }
    }
}
